    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------
    028     * LegendRenderingOrder.java
    029     * -------------------------
    030     * (C) Copyright 2004, 2005, by Object Refinery Limited and Contributors.
    031     *
    032     * Original Author:  Angel;
    033     * Contributor(s):   -;
    034     *
    035     * $Id: LegendRenderingOrder.java,v 1.4.2.1 2005/10/25 16:50:20 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 26-Mar-2004 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * Represents the order for rendering legend items.
    050     */
    051    public final class LegendRenderingOrder implements Serializable {
    052
    053        /** For serialization. */
    054        private static final long serialVersionUID = -3832486612685808616L;
    055
    056        /** In order. */
    057        public static final LegendRenderingOrder STANDARD
    058            = new LegendRenderingOrder("LegendRenderingOrder.STANDARD");
    059
    060        /** In reverse order. */
    061        public static final LegendRenderingOrder REVERSE
    062            = new LegendRenderingOrder("LegendRenderingOrder.REVERSE");
    063
    064        /** The name. */
    065        private String name;
    066
    067        /**
    068         * Private constructor.
    069         *
    070         * @param name  the name.
    071         */
    072        private LegendRenderingOrder(String name) {
    073            this.name = name;
    074        }
    075
    076        /**
    077         * Returns a string representing the object.
    078         *
    079         * @return The string.
    080         */
    081        public String toString() {
    082            return this.name;
    083        }
    084
    085        /**
    086         * Returns <code>true</code> if this object is equal to the specified
    087         * object, and <code>false</code> otherwise.
    088         *
    089         * @param obj  the other object.
    090         *
    091         * @return A boolean.
    092         */
    093        public boolean equals(Object obj) {
    094            if (this == obj) {
    095                return true;
    096            }
    097            if (!(obj instanceof LegendRenderingOrder)) {
    098                return false;
    099            }
    100            LegendRenderingOrder order = (LegendRenderingOrder) obj;
    101            if (!this.name.equals(order.toString())) {
    102                return false;
    103            }
    104            return true;
    105        }
    106
    107        /**
    108         * Ensures that serialization returns the unique instances.
    109         *
    110         * @return The object.
    111         *
    112         * @throws ObjectStreamException if there is a problem.
    113         */
    114        private Object readResolve() throws ObjectStreamException {
    115            if (this.equals(LegendRenderingOrder.STANDARD)) {
    116                return LegendRenderingOrder.STANDARD;
    117            }
    118            else if (this.equals(LegendRenderingOrder.REVERSE)) {
    119                return LegendRenderingOrder.REVERSE;
    120            }
    121            return null;
    122        }
    123
    124    }